%define mods_ver 1.1.1
Name:          sweethome3d
Version:       3.4
Release:       %mkrel 1
Summary:       An application for placing your furniture on a house 2D plan, with a 3D preview
Group:         Graphics
URL:           http://www.sweethome3d.com/
Source0:       http://sourceforge.net/projects/sweethome3d/files/SweetHome3D-source/SweetHome3D-%{version}-src/SweetHome3D-%{version}-src.zip
Source1:       http://sourceforge.net/projects/sweethome3d/files/SweetHome3D-models/3DModels-%{mods_ver}/3DModels-Contributions-%{mods_ver}.zip
Source2:       http://sourceforge.net/projects/sweethome3d/files/SweetHome3D-models/3DModels-%{mods_ver}/3DModels-KatorLegaz-%{mods_ver}.zip
Source3:       http://sourceforge.net/projects/sweethome3d/files/SweetHome3D-models/3DModels-%{mods_ver}/3DModels-Scopia-%{mods_ver}.zip
Source4:       http://sourceforge.net/projects/sweethome3d/files/SweetHome3D-models/3DModels-%{mods_ver}/3DModels-Trees-%{mods_ver}.zip
Source5:       sweethome3d_128x128.png
Source6:       sweethome3d.desktop
Source7:       sweethome3d-script
Patch0:        sweethome3d-3.2-nomacosx.patch
Patch1:        sweethome3d-3.2-build_xml.patch
Patch2:        sweethome3d-3.4-javadoc.patch
License:       GPL
BuildRequires: abbot
BuildRequires: ant
BuildRequires: batik
BuildRequires: desktop-file-utils
BuildRequires: dos2unix
BuildRequires: freehep-util
BuildRequires: freehep-io
BuildRequires: freehep-xml
BuildRequires: gnu-regexp
BuildRequires: icedtea-web
BuildRequires: imagemagick
BuildRequires: iText
BuildRequires: java-devel
BuildRequires: java-javadoc
BuildRequires: java3d
BuildRequires: java3d-javadoc
BuildRequires: java3ds-fileloader
BuildRequires: jdepend
BuildRequires: jdom
BuildRequires: jiprof
BuildRequires: junit
BuildRequires: jpackage-utils
BuildRequires: sunflow
BuildRequires: xerces-j2
BuildRequires: xml-commons-apis
BuildRequires: vectorgraphics
Requires:      batik
Requires:      freehep-util
Requires:      freehep-io
Requires:      freehep-xml
Requires:      icedtea-web
Requires:      iText
Requires:      janino
Requires:      java
Requires:      java3d
Requires:      java3ds-fileloader
Requires:      jpackage-utils
Requires:      sunflow
Requires:      tango-icon-theme
Requires:      vectorgraphics
BuildArch:     noarch

%description
Sweet Home 3D is an interior design Java application for quickly choosing and
placing furniture on a house 2D plan drawn by the end-user, with a 3D preview.

%package 3dmodels
Group:         Graphics
Summary:       Some extra 3DModels for SweetHome3D
Requires:      sweethome3d = %{version}-%{release}

%description 3dmodels
Some extra 3DModels for SweetHome3D.
 
This package contains:
* 3DModels Contributions %{mods_ver}
* 3DModels KatorLegaz %{mods_ver}
* 3DModels Scopia %{mods_ver}
* 3DModels Trees %{mods_ver}

%package javadoc
Group:          Development/Java
Summary:        Javadoc for %{name}

%description javadoc
Sweet Home 3D - An application for placing your furniture on a house 2D plan,
with a 3D preview

This package contains javadoc for %{name}.

%prep

%setup -q -n SweetHome3D-%{version}-src

for j in $(find . -name "*.jar"); do
  mv $j $j.no
done

%patch0 -p0
%patch1 -p0
%patch2 -p0

#rm -rf lib/linux/i386/libj3dcore-ogl-cg.so
#rm -rf lib/linux/i386/libj3dcore-ogl.so
#rm -rf lib/linux/x64/libj3dcore-ogl.so
rm -rf lib/linux
rm -rf lib/macosx
rm -rf lib/windows

pushd lib
  ln -sf $(build-classpath batik-all) batik-svgpathparser-1.7.jar
  ln -sf $(build-classpath java3ds-fileloader) Loader3DS1_2u.jar
  ln -sf $(build-classpath freehep-util) .
  ln -sf $(build-classpath freehep-io) .
  ln -sf $(build-classpath freehep-xml) .
  ln -sf $(build-classpath freehep-graphics2d) .
  ln -sf $(build-classpath freehep-graphicsio) .
  ln -sf $(build-classpath freehep-graphicsio-svg) .
  ln -sf $(build-classpath itext) iText-2.1.7.jar
  ln -sf $(build-classpath java3d/j3dcore) j3dcore.jar
  ln -sf $(build-classpath java3d/j3dutils) j3dutils.jar
# FIXME use fmj
   mv jmf.jar.no jmf.jar
#  ln -sf $(build-classpath fmj/fmj) jmf.jar
  ln -sf $(build-classpath sunflow) sunflow-0.07.3g.jar
  ln -sf $(build-classpath java3d/vecmath) vecmath.jar
popd

pushd libtest
#  mv AppleJavaExtensions.jar.no AppleJavaExtensions.jar

  ln -sf $(build-classpath abbot) abbot.jar
  ln -sf $(build-classpath gnu-regexp) gnu-regexp-1.1.0.jar
  ln -sf $(build-classpath jdepend) jdepend-2.9.jar
  ln -sf $(build-classpath jdom) jdom-1.0.jar
#  mv jnlp.jar.no jnlp.jar
  ln -sf /usr/share/icedtea-web/netx.jar jnlp.jar
  ln -sf $(build-classpath jiprof/profile) profile.jar
popd

for c in $(find lib -name "*.class"); do
  rm -f $c
done

dos2unix  *.TXT
chmod 644 *.TXT

mkdir -p 3DModels-Contributions
pushd 3DModels-Contributions
    unzip -q %{SOURCE1}
    mv README.TXT README-3DModels-Contributions.txt
    mv LICENSE.TXT LICENSE-3DModels-Contributions.txt
popd
mkdir -p 3DModels-KatorLegaz
pushd 3DModels-KatorLegaz
    unzip -q %{SOURCE2}
    mv README.TXT README-3DModels-KatorLegaz.txt
    mv LICENSE.TXT LICENSE-3DModels-KatorLegaz.txt
popd
mkdir -p 3DModels-Scopia
pushd 3DModels-Scopia
    unzip -q %{SOURCE3}
    mv README.TXT README-3DModels-Scopia.txt
    mv LICENSE.TXT LICENSE-3DModels-Scopia.txt
popd
mkdir -p 3DModels-Trees
pushd 3DModels-Trees
    unzip -q %{SOURCE4}
    mv README.TXT README-3DModels-Trees.txt
    mv LICENSE.TXT LICENSE-3DModels-Trees.txt
popd

%build

%ant application furniture textures help javadoc

%install
[ "%{buildroot}" != / ] && rm -rf "%{buildroot}"

mkdir -p %{buildroot}%{_javadir}/sweethome3d

install -pm 644 build/SweetHome3D.jar \
  %{buildroot}%{_javadir}/sweethome3d/SweetHome3D-%{version}.jar

(
  cd %{buildroot}%{_javadir}/sweethome3d
  for jar in *-%{version}*; do
    ln -sf ${jar} `echo $jar| sed  "s|-%{version}||g"`
  done
)

for i in Furniture Textures Help; do
    install -pm 644 build/$i.jar %{buildroot}%{_javadir}/sweethome3d
done

mkdir -p %{buildroot}%{_javadocdir}/sweethome3d
cp -pr javadoc/* %{buildroot}%{_javadocdir}/sweethome3d

rm -rf lib/iText-2.1.7.jar
rm -rf lib/j3dcore.jar
rm -rf lib/j3dutils.jar
rm -rf lib/sunflow-0.07.3g.jar
rm -rf lib/vecmath.jar
rm -rf lib/Loader3DS1_2u.jar

# FIXME lib/jmf.jar
install -pm 644 lib/jmf.jar %{buildroot}%{_javadir}/sweethome3d
# install -pm 644 libtest/jnlp.jar %{buildroot}%{_javadir}/sweethome3d
#ln -sf /usr/share/icedtea-web/netx.jar %{buildroot}%{_javadir}/sweethome3d/jnlp.jar

mkdir -p %{buildroot}%{_datadir}/sweethome3d
for i in Contributions KatorLegaz Scopia Trees; do
    install -m 644 3DModels-$i/*.sh3f %{buildroot}%{_datadir}/sweethome3d
done

for png in 64x63 32x32 22x22 16x16; do
  mkdir -p %{buildroot}%{_datadir}/icons/hicolor/${png}/apps/
  convert -geometry $png %{SOURCE5} %{buildroot}%{_datadir}/icons/hicolor/${png}/apps/sweethome3d.png
done

mkdir -p %{buildroot}%{_datadir}/icons/hicolor/128x128/apps/
install -m 644 %{SOURCE5} %{buildroot}%{_datadir}/icons/hicolor/128x128/apps/sweethome3d.png

mkdir -p %{buildroot}%{_datadir}/pixmaps
install -pm 644 %{SOURCE5} %{buildroot}%{_datadir}/pixmaps/sweethome3d.png

mkdir -p %{buildroot}%{_datadir}/applications
desktop-file-install --mode=0644 --dir=%{buildroot}%{_datadir}/applications %{SOURCE6}

mkdir -p %{buildroot}%{_bindir}
install -m 755 %{SOURCE7} %{buildroot}%{_bindir}/sweethome3d

%check
desktop-file-validate %{buildroot}%{_datadir}/applications/sweethome3d.desktop


%files
%{_bindir}/sweethome3d
%dir %{_javadir}/sweethome3d
%{_javadir}/sweethome3d/Furniture.jar
%{_javadir}/sweethome3d/Help.jar
%{_javadir}/sweethome3d/SweetHome3D-%{version}.jar
%{_javadir}/sweethome3d/SweetHome3D.jar
%{_javadir}/sweethome3d/Textures.jar

# FIXME
%{_javadir}/sweethome3d/jmf.jar

#%{_javadir}/sweethome3d/jnlp.jar
%{_datadir}/applications/sweethome3d.desktop
%{_datadir}/icons/hicolor/*x*/apps/sweethome3d.png
%{_datadir}/pixmaps/sweethome3d.png
%doc COPYING* LICENSE.TXT README.TXT


%files 3dmodels
%dir %{_datadir}/sweethome3d
%{_datadir}/sweethome3d/*.sh3f
%doc 3DModels-Contributions/*.txt 3DModels-KatorLegaz/*.txt 3DModels-Scopia/*.txt 3DModels-Trees/*.txt

%files javadoc
%{_javadocdir}/sweethome3d



%changelog

* Sat Dec 31 2011 gil <gil> 3.4-1.mga2
+ Revision: 189182
- fixed launcher script
- update to 3.4
  update patch2
  new BR/R batik
  updated launcher script
- update to 3.3
- imported package sweethome3d

  + dmorgan <dmorgan>
    - Clean spec file


* Thu Jun 09 2011 gil <gil> 3.2-2.%%mkrel
- add abbot support
- add javadoc sub package

* Wed Jun 08 2011 gil <gil> 3.2-1.%%mkrel
- add freehep-{util,io,xml} java3ds-fileloader vectorgraphics support

* Wed Jun 01 2011 gil <gil> 3.2-0.%%mkrel
- initial rpm